<?php 
/* rec2ts.php - Convert Toppy .rec to .ts (and back again) */ 

//php 4 function
if (!function_exists("str_split")) {
	function str_split($str,$length = 1) {
	 if ($length < 1) return false;
	 $strlen = strlen($str);
	 $ret = array();
	 for ($i = 0; $i < $strlen; $i += $length) {
		 $ret[] = substr($str,$i,$length);
	 }
	 return $ret;
	}
}

/* Rename converted file? */ 
$dorename = TRUE; 

if(count($argv) > 2) {
	$filename = $argv[2];
} else { 
	exit("No filename supplied\n"); 
}	

$handle = @fopen($filename, 'r+b'); 
if($handle === FALSE) 
	exit("Failed to open: $filename\n"); 

fseek($handle,0); 
$hdr = fread($handle, 3760); 
if($hdr === FALSE) 
	exit("Error reading from: $filename\n"); 

$arr = str_split($hdr,188); 
if($arr[0][0]==chr(0x47)) { 
	foreach($arr as $key => $_) { 
		for($i=0; $i < 3; $i++) 
			$arr[$key][$i] = $arr[19][$key * 3 + 3 + $i]; 
	} 
	echo "Reverted to Topfield REC file\n"; 
	$newname = preg_replace('/.ts$/i','.rec',$filename); 
} else { 
	$repl = array(chr(0x47),chr(0x1F),chr(0xFF)); 
	foreach($arr as $key => $_) { 
		for($i=0; $i < 3; $i++) { 
			$arr[19][$key * 3 + 3 + $i] = $arr[$key][$i]; 
			$arr[$key][$i] = $repl[$i]; 
		} 
	} 
	echo "Converted to TS file\n"; 
	$newname = preg_replace('/.rec$/i','.ts',$filename); 
} 

// Write the string to the file 
fseek($handle,0); 
if(fwrite($handle, implode("",$arr)) === FALSE) 
	exit("Error writing to $filename\n"); 

fclose($handle); 

// Rename the file if needed 
if($dorename && $newname !== $filename) 
	rename($filename,$newname); 

/* End */ 
?>